require 'sketchup.rb'
require 'extensions.rb'

if Sketchup.version.to_i >= 16

module AMS
  module ClothWorks

    NAME = 'ClothWorks'.freeze

    MAJOR_VERSION = 1.freeze
    MINOR_VERSION = 7.freeze
    PATCH_VERSION = 7.freeze
    DEVEL_VERSION = 0.freeze

    VERSION_INT = (MAJOR_VERSION * 1000 + MINOR_VERSION * 100 + PATCH_VERSION * 10 + DEVEL_VERSION).to_i
    VERSION = sprintf("%d.%d.%d%c", MAJOR_VERSION, MINOR_VERSION, PATCH_VERSION, DEVEL_VERSION + 0x61).freeze

    REQUIRED_SKETCHUCATION_VERSION = "4.0.0".freeze

    RELEASE_YEAR_START = 2018.freeze
    RELEASE_YEAR_END = 2022.freeze
    RELEASE_DATE = '2 May 2022'.freeze

    cfpath = __FILE__.dup
    cfpath.force_encoding('UTF-8') if cfpath.respond_to?(:force_encoding)
    dir = ::File.expand_path(::File.dirname(cfpath))
    fpath = ::File.join(dir, "ams_ClothWorks/main")
    @extension = ::SketchupExtension.new(NAME, fpath)

    desc = "A cloth simulator for SketchUp"

    @extension.description = desc
    @extension.version     = VERSION
    @extension.copyright   = "(C) #{RELEASE_YEAR_START} - #{RELEASE_YEAR_END} Anton Synytsia"
    @extension.creator     = 'Anton Synytsia'

    ::Sketchup.register_extension(@extension, true)

    class << self
      attr_reader :extension
    end # class << self

  end # module ClothWorks
end # module AMS

else
  UI.messagebox("ClothWorks requires SketchUp 2016 or later to work! ClothWorks is not compatible with your SketchUp version and will, therefore, not be loaded.")
end
