/*
 * ---------------------------------------------------------------------------------------------------------------------
 *
 * Copyright (C) 2019 Anton Synytsia
 *
 * ---------------------------------------------------------------------------------------------------------------------
 */

var g_ms_ie = null;
var g_chrome = null;

String.prototype.contains = function(it) {
  return this.indexOf(it) != -1;
};

function callback(name, data) {
  if (!data) data = '';
  if (typeof sketchup === 'undefined') {
    window.location.href = 'skp:' + name + '@' + data;
  } else {
    var f = window['sketchup'][name];
    if (f !== undefined) f(data);
  }
}

function init() {
  var cw = $(window).width();
  var ch = $(window).height();
  var bw = 1000;
  var bh = 400;
  var data =
    '[' +
    String(cw) +
    ',' +
    String(ch) +
    ',' +
    String(bw) +
    ',' +
    String(bh) +
    ']';

  callback('init', data);
}

function eval_string_to_float(str) {
  var num = 0.0;
  try {
    with (Math) {
      num = eval(str);
    }
  } catch (err) {
    return 0.0;
  }
  if (typeof num != 'number' || num === NaN || num === Infinity) return 0.0;
  return num;
}

function clamp_number(number, min, max) {
  if (number < min) {
    return min;
  } else if (number > max) {
    return max;
  } else {
    return number;
  }
}

function set_console(str) {
  $('#console').val(str);
}

function blur_input() {
  if (document.activeElement instanceof HTMLInputElement) {
    document.activeElement.blur();
  }
}

$(document).ready(function() {
  // Browser stuff
  var ua = window.navigator.userAgent;
  var old_ie = ua.indexOf('MSIE ');
  var new_ie = ua.indexOf('Trident/');

  g_ms_ie = old_ie > -1 || new_ie > -1 ? true : false;
  g_chrome = ua.toLowerCase().indexOf('chrome') > -1 ? true : false;

  // Handle errors
  window.onerror = function(msg, url, linenumber) {
    alert('Error: ' + msg + '\nLine: ' + linenumber);
    return true;
  };

  // Handle focus
  $(window).blur(function() {
    blur_input();
  });

  // Initialize
  window.setTimeout(init, 0);
});
